/********************************************************************
	7SEG CLOCK Ver 1.0

	PORTA 0,1,2,3 = _Ci~bN_؂ւB7SEGẽAm[hɐڑ
		  4 	= {^[hؑ(vAbvj
		@@5		= MCLR
		  6,7   = NbN
	PORTB 0-7   = 7SEG LED̃J\[h
	TMR1		= \p̊݃^C}
	TMR0		= XgbvEIb`Eėp̊݃^C}
*********************************************************************/
#include <htc.h>
#define _XTAL_FREQ 11776000

__CONFIG(UNPROTECT & LVPDIS & BORDIS & MCLREN & PWRTEN & WDTDIS & HS);
__IDLOC(F648);

static unsigned int watch, stp_watch;			// EIb` WORK
static long t_save, w_save;						//@v WORK
static unsigned char dg_f, dgt[4], dot[4],		// \ WORK
					 hh, mm, ss,				// EEb
					 dsp_mode, 					// \[h
					 slp_on, wat_on;			// X[vAEIb`
static const char dig[];						// Ep^[(QƂ̒`)

#define MODE_CLOCK	0							// v[h
#define MODE_SECOND	1							// b\[h
#define MODE_WATCH	2							// XgbvEIb`[h
#define MODE_ADJHH	3							// Eݒ
#define MODE_ADJMM	4							// Eݒ
#define MODE_SLEEP	5							// X[vݒ
#define DSP_DOT		16							// LED̃hbg
#define DSP_OFF		17							// LED OFF
#define DSP_n		18							// LED̂
#define DSP_L		19							// LEDL
#define DSP_P		20							// LEDP
#define SWT_MODE	RA4							// [hXCb`̃|[g
#define SWT_1		RB2							// XCb`P̃|[g
#define SWT_2		RB3							// XCb`Q̃|[g
#define TRIS_1		TRISB2						// XCb`P̓
#define TRIS_2		TRISB3						// XCb`Q̓
#define SLP_SEC		300							// X[v@30.0b

void disp() {									// \֐
	long tmp;

	dot[0] = dot[1] = dot[2] = dot[3] = 0xFF;	// hbgNA
	switch (dsp_mode) {
		case MODE_CLOCK:						// AݒAݒ̕\
		case MODE_ADJHH:
		case MODE_ADJMM:
			dgt[3] = hh / 10;					// 
			dgt[2] = hh % 10;
			dgt[1] = mm / 10;					// 
			dgt[0] = mm % 10;
			dot[2] = dig[DSP_DOT];				// 2ڂɃhbg
			break;
		case MODE_SECOND:						// b\
			dgt[1] = ss / 10;
			dgt[0] = ss % 10;
			break;
		case MODE_WATCH:						// XgbvEIb`̕\
			tmp = stp_watch;					// JE^l10Ŋ邽߂̕ϐ
			dgt[0] = tmp % 10;					// 10̏]
			tmp /= 10;
			dgt[1] = tmp % 10;
			tmp /= 10;
			dgt[2] = tmp % 10;
			tmp /= 10;
			dgt[3] = tmp % 10;
			dot[1] = dig[DSP_DOT];				// 3ڂɃhbg
			break;
	}
	if (slp_on == 2) {							// X[v̓hbĝݕ\
		dgt[0] = DSP_DOT;
	}
	PORTB = 0b11111111;							// PORTBNA
	switch (dg_f) {								// 0-3̏
		case 0:
			PORTA = (PORTA & 0xF0) | 0b0001;	// PORTȀo
			PORTB = dig[dgt[0]] & dot[0];		// PORTB͐{hbg
			break;
		case 1:
			PORTA = (PORTA & 0xF0) | 0b0010;
			PORTB = dig[dgt[1]] & dot[1];
			break;
		case 2:
			PORTA = (PORTA & 0xF0) | 0b0100;
			PORTB = dig[dgt[2]] & dot[2];
			break;
		case 3:
			PORTA = (PORTA & 0xF0) | 0b1000;
			PORTB = dig[dgt[3]] & dot[3];
			break;
	}
}


static interrupt int_server(void) {				// ݏ
	if (TMR1IF) {								// TMR1
		TMR1IF = 0;								// tONA
		t_save += 0x10000;						// TMR11TAbv
//		if (t_save > 250000) {					// 4MHZ̏ꍇ1b
		if (t_save > 736000) {					// 11.776MHz̏ꍇ1b
			ss++;								// 1bǉ
			t_save -= 736000;					// 1bJE^
			if (ss >= 60){						// 60b=1
				mm++;
				ss=0;
			}
			if (mm >= 60) {						// 60=1
				hh++;
				mm=0;
			}
			if (hh >= 24)						// 24=0
				hh = 0;
		}
	}
	if (T0IF) {									// TMR0
		T0IF = 0;								// tONA
		w_save += 0x4000;						// TMR01TAbv
		if (w_save > 73600) {					// 0.1bJE^
			w_save -= 73600;					// JE^
			watch++;							// ̕ϐ̓Abv̂
			if (wat_on)							// XgbvEIb`ғȂ
				stp_watch++;					// XgbvEIb`pϐAbv
				if (stp_watch > 10000)			// 1000.0b0ɖ߂
					stp_watch = 0;
		}
	}
}

void main()
{
	unsigned int slp_stt;						// ϐ̐錾
	unsigned char blink, disp_on, slp_disp;

	OPTION 	= 0b00000111;						// ^C} T0CS(CLOCK=internal), T0SE(Out=N/A)
												//		PSA(TMR0)=0, PRESCALSE=1:256
	TRISB	= 0x00000000;						// o͐ݒ
	CMCON	= 0b00000111;						// Rp[^gp
	PORTA 	= 0;								// PORTANA
	TRISA	= 0b11110000;						// o͐ݒ IN=4-7
	T0IE = 1;									// TMR0
	TMR1IE = 1;									// TMR1
	T1CKPS1 = 1;
	T1CKPS0 = 0;								// TMR1 PRESCALE=1:4
	TMR1H = 0x00;								// TMR1 l
	TMR1L = 0x00;
	TMR1ON = 1;									// TMR1I
	TMR1IF = 0;									// TMR1݃tONA
	GIE = 1;									// S̊ON
	dsp_mode = MODE_CLOCK;						// [hl͎\
	dg_f = 0;									// 0
	ss = mm = hh = 0;							// 
	t_save = w_save = watch = 0;				// JE^
	disp_on = 1;								// \I
	slp_on  = wat_on = 0;						// X[vAXgbvEIb`̃NA
	__delay_ms(50);								// 50ms҂
	while(1){									// JԂ[v
		if (!SWT_MODE) {						// [hXCb`ꂽ
			PORTB = 0xFF;						// \NA
			__delay_ms(50);						// 100ms҂(`^Oh~j
			__delay_ms(50);
			if (!SWT_MODE) {					// ܂Ă
				if (slp_on == 2) {				// X[v̏ꍇAN
					slp_on = 1;
					slp_stt = watch;
				} else {
					dsp_mode++;					// ̃[hֈڍs
					slp_disp = 0;
					if (dsp_mode > MODE_SLEEP)	// X[v͎̎[h
						dsp_mode = MODE_CLOCK;
					disp_on = 0;
				}
			}
		} else {
			disp_on = 1;
		}
		if (dsp_mode > MODE_CLOCK) {			// [hȊO
			TRIS_1 = 1;							// XCb`P̃|[g͂ɂ
			__delay_us(10);						// 10us҂
			if(!SWT_1) {						// XCb`PĂ
				PORTB = 0xFF;
				__delay_ms(50);
				__delay_ms(50);
				if(!SWT_1) {
					if (slp_on == 2) {
						slp_on = 1;
						slp_stt = watch;		// X[v֓邽߂̃JE^
					} else {
						switch (dsp_mode) {
							case MODE_SECOND:	// b[h̎
								t_save = 0;		// 0Zbg
								ss = 0;
								break;
							case MODE_ADJHH:	// ݒ̎A
								hh++;			// JEgAbv
								break;
							case MODE_ADJMM:	// ݒ̎A
								mm++;			// JEgAbv
								break;
							case MODE_WATCH:	// XgbvEIb`̎
								stp_watch = 0;	// 0Zbg
								break;
						}
					}						
				}
			}
			TRIS_1 = 0;							// XCb`P̃|[go͂ɖ߂
			TRIS_2 = 1;							// XCb`Q̃|[g͂ɂ
			__delay_us(10);
			if(!SWT_2) {						// XCb`Qꂽ
				PORTB = 0xFF;
				__delay_ms(50);
				__delay_ms(50);
				if(!SWT_2) {
					if (slp_on == 2) {
						slp_on = 1;
						slp_stt = watch;
					} else {
						switch (dsp_mode) {
							case MODE_WATCH:		// XgbvEIb`̎
								wat_on = !wat_on;	// X^[gEXgbv؂ւ
								break;
							case MODE_SLEEP:		// X[v[h̎
								slp_disp++;			// X[v\̐؂ւ
								if (slp_disp == 2) slp_on = 1;
								else slp_on = 0;
								if (slp_disp > 2) slp_disp = 1;
								break;
						}
					}
				}
			}
			TRIS_2 = 0;
		}

		if (watch % 10 < 5)							// uN0.5bƂɐ؂ւ		
			blink = 1;
		else
			blink = 0;
		switch (dsp_mode) {							// \̗}
			case MODE_SECOND:						// b\F2̂
				if (dg_f > 1)
					dg_f = 0;
			case MODE_ADJHH:						// ݒ
				if (blink &&  dg_f > 1)				// uNIŏ2}
					dg_f = 0;						// 	01
				break;
			case MODE_ADJMM:						// ݒ
				if (blink &&  dg_f < 2)				// uNItł2}
					dg_f = 2;						// 23
				break;
			case MODE_SLEEP:						// X[v[h
				switch (slp_disp) {
					case 0: dgt[2] = 5;				// X[v[hI=0
							dgt[1] = DSP_L;			// SLPƕ\(S5őpj
							dgt[0] = DSP_P;
							if (dg_f > 2)
								dg_f = 0;
							break;
					case 1: dgt[2] = 0;				// X[vI=1
							dgt[1] = dgt[0] = 0xF;	// OFFƕ\
							dgt[0] = dgt[0] = 0xF;
							if (dg_f > 2)
								dg_f = 0;
							break;
					case 2: dgt[1] = 0;				// X[vI=2
							dgt[0] = DSP_n;			// Onƕ\
							if (dg_f > 1)
								dg_f = 0;
							break;
				}
				break;
		}
		if (slp_on == 1) {							// X[vIȂ
			if (watch - slp_stt > SLP_SEC) {		// X[vݒ莞(30b)
				slp_on = 2;							// X[v
			}
		}
		if (slp_on == 2) {							// X[vȂ
			PORTB = 0xFF;							// ݂LED̓It
			dg_f = 0;								// 1ڂ̂ݕ\
			disp_on = blink;						// uNɑΉ
		}
		if (disp_on)								// \tOIȂ
			disp();									// \֐Ăяo
		dg_f++;										// \Abv
		if (dg_f > 3)								// 4ڂ̎
			dg_f = 0;								// 1
		__delay_ms(1);
	}
}

static const char dig[] ={							// E`(0I)
		0b11000000,		//0
		0b11111001,		//1
		0b10100100,		//2
		0b10110000,		//3
		0b10011001,		//4
		0b10010010,		//5
		0b10000010,		//6
		0b11111000,		//7
		0b10000000,		//8
		0b10010000,		//9
		0b10001000,		//A
		0b10000011,		//B
		0b11000110,		//C
		0b10100001,		//D
		0b10000110,		//E
		0b10001110,		//F
		0b01111111,		//. (G)
		0b11111111,		//All Off
		0b10101011,		//n
		0b11000111,		//L
		0b10001100		//P
	};
